
var keyboardkeyslist = {48:'0',49:'1',50:'2',51:'3',52:'4',53:'5',54:'6',55:'7',56:'8',57:'9',97:'A',98:'B',99:'C',100:'D',101:'E',102:'F',103:'G',104:'H',105:'I',106:'J',107:'K',108:'L',109:'M',110:'N',111:'O',112:'P',113:'Q',114:'R',115:'S',116:'T',117:'U',118:'V',119:'W',120:'X',121:'Y',122:'Z'};

jQuery(document).ready(function() {
	// load the scenario
	$('#load_scenario').click(function(){
		dialog.showOpenDialog((filenames) => {
			if(filenames === undefined){
				return;
			}
			// prepare find paths for replacement
			configdata.musicpathfind = configdata.musicpathfind.replace(/\\/ig, '\\\\');
			configdata.soundpathfind = configdata.soundpathfind.replace(/\\/ig, '\\\\');
			fs.readFile(filenames[0], 'utf-8', (err, data) => {
				if(err){
					alert(langstrings.error_loadfile + err.message);
					return;
				}
				var filemode = '';
				var loadfolder = false;
				var lastlist = false;
				// split lines
				let lines = data.split(/\r?\n/);
				if(lines !== undefined && lines.length > 0) {
					var i = 1;
					var ul = false;
					$('#playlistbox').empty();
					$('#soundlistbox').empty();
					$.each(lines,function(i,line){
						let blocks = line.trim().split(/(?<!\\);/);
						if(line != '' && blocks !== undefined && blocks.length > 0) {
							let dynlist = 0;
							if($.inArray(blocks[0],['music','sounds']) !== -1) {
								filemode = blocks[0];
							}
							if(filemode == 'music') {
								if(blocks[0] == 'block') {
									ul = $('<ul/>').addClass('playlist').attr('listname','playlist'+i).attr('listnamenice',cleartext(blocks[1])).attr('istitle',1).appendTo($('#playlistbox'));
								}
								if(blocks[0] == 'playlist') {
									let randomlist = (blocks[4] != 0) ? 1 : 0;
									let dynlist = (blocks[5] != 1) ? 0 : 1;
									loadfolder = (blocks[5] == 1) ? true : false;
									let hotkey = (blocks[6] > 0) ? blocks[6] : 0;
									ul = $('<ul/>').addClass('playlist').attr('listname','playlist'+i).attr('listnamenice',cleartext(blocks[1])).attr('istitle',0).attr('icon',blocks[3]).attr('bgcolor',blocks[2]).attr('random',randomlist).attr('dynlist',dynlist).attr('hotkey',hotkey).attr('currentpos',0).appendTo($('#playlistbox'));
								}
							}
							else if (filemode == 'sounds') {
								if(blocks[0] == 'block') {
									ul = $('<ul/>').addClass('soundlist').attr('listname','soundlist'+i).attr('listnamenice',cleartext(blocks[1])).attr('istitle',1).appendTo($('#soundlistbox'));
								}
								if(blocks[0] == 'soundlist') {
									let repeatlist = (blocks[5] != 'none' && blocks[5] != 'once') ? 1 : 0;
									let playlistonce = (blocks[5] == 'once') ? 1 : 0;
									let randomlist = (blocks[6] != 0) ? 1 : 0;
									let dynlist = (blocks[7] != 1) ? 0 : 1;
									loadfolder = (blocks[7] == 1) ? true : false;
									let volume = (blocks[4] == 0) ? '0.0' : ((blocks[4] == 1) ? '1.0' : blocks[4]);
									let hotkey = (blocks[8] > 0) ? blocks[8] : 0;
									ul = $('<ul/>').addClass('soundlist').attr('listname','soundlist'+i).attr('listnamenice',cleartext(blocks[1])).attr('istitle',0).attr('icon',blocks[3]).attr('bgcolor',blocks[2]).attr('repeat',repeatlist).attr('playlistonce',playlistonce).attr('random',randomlist).attr('dynlist',dynlist).attr('repeatspeed',((blocks[5] != 'none') ? blocks[5]*1000 : 0)).attr('volume',volume).attr('hotkey',hotkey).attr('currentpos',0).appendTo($('#soundlistbox'));
								}
							}
							if(blocks[0] == 'file') {
								if(loadfolder) {
									let folder = cleartext(blocks[1]);
									if(filemode == 'music') {
										let r = new RegExp(configdata.musicpathfind,'i');
										folder = folder.replace(r,configdata.musicpathreplace);
									}
									else {
										let r = new RegExp(configdata.soundpathfind,'i');
										folder = folder.replace(r,configdata.soundpathreplace);
									}
									fs.readdirSync(folder).forEach(file => {
										var filename = folder+'\\'+file;
										let stat = fs.statSync(filename);
										if(!stat.isDirectory()){
											let result = filename.match(/\.([a-z0-9]*)$/ig);
											if(result !== null && result[0] && $.inArray(result[0],['.wav','.mp3','.ogg','.oga','.webm']) !== -1) {
												$('<li/>').text(file).attr('audiourl',filename.replace(/\\/g,'/')).click(function() {find_audio($(this).parent().attr('listname'),$(this).index());$(this).blur();}).appendTo(ul);
											}
										}
									});
								}
								else {
									let file = splitfile(cleartext(blocks[1]));
									if(filemode == 'music') {
										let r = new RegExp(configdata.musicpathfind,'i');
										file.path = file.path.replace(r,configdata.musicpathreplace);
									}
									else {
										let r = new RegExp(configdata.soundpathfind,'i');
										file.path = file.path.replace(r,configdata.soundpathreplace);
									}
									console.log(blocks[2]);
									let volume = (typeof blocks[2] !== 'undefined' && blocks[2] != '') ? parseFloat(blocks[2]) : parseFloat(1);
									console.log(volume);
									$('<li/>').text(file.name).attr('volume',volume).attr('audiourl',file.path.replace(/\\/g,'/')).click(function() {find_audio($(this).parent().attr('listname'),$(this).index());$(this).blur();}).appendTo(ul);
								}
							}
							i++;
						}
					});
					playlist_init();
					$('#mode_select').removeClass('visible');
					$('#buttonbox').addClass('visible');
				}
			});
		});
	});
	$('#new_scenario').click(function(){
		window.location = "index_setup.html";
	});

	// variables
	var fade_time = 2;
	var fade_step = (fade_time / 20 * 1000);
	var fade_time_sound = 2;
	var fade_step_sound = (fade_time_sound * 1000);
	var track_active = 0;
	var playlist_active = 0;
	var trackvolume = .5;
	var track_last = 0;
	var playlist_last = 0;
	var playlist_active_name = '';
	var playlists = [{}];
	var track_last_timeout;
	var last_track_switch = 0;
	var tape_side = 'trackb';
	var last_tape_side = 'trackb';
	var audioplayer = {'tracka':new Audio(),'trackb':new Audio()};
	var audioplayer_volume = {'tracka':1,'trackb':1};
	var audiolast = {};
	var soundlast = {};
	var soundplayer = [];
	var soundloops = {};
	var b = 0;
	// init playlist
	function playlist_init() {
		// create playlist
		$('ul.playlist').each(function() {
			// create playlist buttons
			if($(this).attr('istitle') == "1") {
				$('div.playlists').append($('<div/>').addClass('listtitle').html('<span>'+$(this).attr('listnamenice')+'</span>'));
			}
			else {
				var listname = $(this).attr('listname');
				playlists[b] = {'name':listname,'namenice':$(this).attr('listnamenice'),'tracks':[{}]};
				var c = 0;
				$(this).children('li').each(function() {
					playlists[b]['tracks'][c] = {'audio':$(this).attr('audiourl'),'name':$(this).text(),'volume':$(this).attr('volume')};
					c++;
				});
				let blockicon = ($(this).attr('icon') != '') ? '<i class="'+$(this).attr('icon')+'"></i>' : '';
				let hotkey = ($(this).attr('hotkey') > 0) ? $(this).attr('hotkey') : '';
				let hotkeytext = ($(this).attr('hotkey') > 0) ? '['+keyboardkeyslist[hotkey]+'] ' : '';
				let thebutton = $('<button/>');
				thebutton.attr('listname',$(this).attr('listname')).attr('hotkey',hotkey).html(blockicon+hotkeytext+$(this).attr('listnamenice')).attr('style','background-color:'+$(this).attr('bgcolor')).click(function(){
					click_playlistbutton(listname);
				});
				$('div.playlists').append(thebutton);
				b++;
			}
		});
		// create soundlist
		$('ul.soundlist').each(function() {
			var listname = $(this).attr('listname');
			// create playlist buttons
			if($(this).attr('istitle') == "1") {
				$('div.soundlists').append($('<div/>').addClass('listtitle').html('<span>'+$(this).attr('listnamenice')+'</span>'));
			}
			else {
				var soundblock = $('<div />').addClass('soundblock');
				soundblock.disableTextSelect();
				var nameblock = $('<div />').addClass('nameblock');
				nameblock.click(function(){
					play_sounds(listname);
					$(this).blur();
				});
				let blockicon = ($(this).attr('icon') != '') ? '<i class="'+$(this).attr('icon')+'"></i>' : '';
				let hotkey = ($(this).attr('hotkey') > 0) ? $(this).attr('hotkey') : '';
				let hotkeytext = ($(this).attr('hotkey') > 0) ? '['+keyboardkeyslist[hotkey]+'] ' : '';
				nameblock.html(blockicon+hotkeytext+$(this).attr('listnamenice')).attr('hotkey',hotkey).attr('style','background-color:'+$(this).attr('bgcolor'));
				var btnblock = $('<div />').addClass('btnblock').attr('listname',listname);
				var playbtn = $('<div/>').addClass('btn').click(function(){
					click_soundlistbutton(listname);
				}).html('<i class="fa fa-play-circle"></i>');
				btnblock.append(playbtn);
				var stopbtn = $('<div/>').addClass('btn stopsound').click(function(){
					stop_sounds(listname);
					$(this).blur();
				}).html('<i class="fa fa-stop-circle"></i>');
				btnblock.append(stopbtn);
				var repeatbtn = $('<span/>').addClass('repeat').html('<i class="fa fa-repeat"></i>').addClass(($(this).attr('repeat') == 1) ? 'active' : 'inactive');
				btnblock.append(repeatbtn);
				var volumeblock = $('<div />').addClass('toright');
				var volumebtn = $('<span/>').addClass('volume').html($(this).attr('volume'));
				volumeblock.append(volumebtn);
				var volupbtn = $('<div/>').addClass('btn').click(function(){
					sounds_volume(listname,'up');
					$(this).blur();
				}).html('<i class="fa fa-volume-up"></i>');
				volumeblock.append(volupbtn);
				var voldownbtn = $('<div/>').addClass('btn').click(function(){
					sounds_volume(listname,'down');
					$(this).blur();
				}).html('<i class="fa fa-volume-down"></i>');
				volumeblock.append(voldownbtn);
				btnblock.append(volumeblock);
				soundblock.append(nameblock).append(btnblock);
				$('div.soundlists').append(soundblock);
			}
		});
		// play click
		$('.play').click(function (e) {
			e.preventDefault();
			audioplayer[tape_side].play();
			audio_fadein(tape_side,0);
			$('.play').addClass('hidden');
			$('.pause').addClass('visible');
		});
		// pause click
		$('.pause').click(function (e) {
			e.preventDefault();
			audio_fadeout(tape_side,trackvolume);
			$('.play').removeClass('hidden');
			$('.pause').removeClass('visible');
		});
		// forward click
		$('.fwd').click(function (e) {
			e.preventDefault();
			play_playlist(playlist_active_name,false);
		});
		$('.currentvolume').html(trackvolume.toFixed(1));
		// volume
		$('.ctrlbutton .up').click(function() {
			audio_volume('up');
		})
		$('.ctrlbutton .down').click(function() {
			audio_volume('down');
		})
		$('#stopsounds').click(function(e) {
			e.preventDefault();
			stopmusic();
			stopallsounds();
		});
		// catch click on slidebar
		$('div.musictime > .slidebar').click(function(e){
			let sc = e.offsetX / $(this).width();
			audioplayer[tape_side].currentTime = audioplayer[tape_side].duration * sc;
		});

		// make tabs
		$('#tab1').click(function(){
			if(!$('#tab1').hasClass('active')) {
				$('#tab3').removeClass('active');
				$('#tab1').addClass('active');
				$('#tab2').removeClass('active');
				$('#buttonbox').addClass('visible');
				$('#soundbox').removeClass('visible');
				$('#playlistbox').removeClass('visible');
			}
			$(this).blur();
		});
		$('#tab2').click(function(){
			if(!$('#tab2').hasClass('active')) {
				$('#tab3').removeClass('active');
				$('#tab2').addClass('active');
				$('#tab1').removeClass('active');
				$('#buttonbox').removeClass('visible');
				$('#soundbox').removeClass('visible');
				$('#playlistbox').addClass('visible');
			}
			$(this).blur();
		});
		$('#tab3').click(function(){
			if(!$('#tab3').hasClass('active')) {
				$('#tab3').addClass('active');
				$('#tab2').removeClass('active');
				$('#tab1').removeClass('active');
				$('#buttonbox').removeClass('visible');
				$('#playlistbox').removeClass('visible');
				$('#soundbox').addClass('visible');
			}
			$(this).blur();
		});
	}

	// key press
	$(document).on('keypress', function(e) {
		if(e.which in keyboardkeyslist) {
			var btn = $('.playlists button[hotkey="'+e.which+'"]');
			if(btn.length > 0) {
				click_playlistbutton(btn.attr('listname'));
			}
			else {
				var sbtn = $('.soundlists .nameblock[hotkey="'+e.which+'"]');
				if(sbtn.length > 0) {
					click_soundlistbutton(sbtn.siblings('.btnblock').attr('listname'));
				}
			}
		}
	});
	// button click
	function click_playlistbutton(listname) {
		play_playlist(listname,true);
		$(this).blur();
	}
	function click_soundlistbutton(listname) {
		play_sounds(listname);
		$(this).blur();
	}
	// play random from playlist
	function play_playlist(playlist_name,init) {
		$('.controlsbox').removeClass('hidden');
		var playlist_id = 0;
		for(var i=0;i<playlists.length;i++) {
			if(playlists[i].name == playlist_name) {
				playlist_id = i;
			}
		}
		var s = $('.playlist[listname="'+playlist_name+'"]');
		var randomlist = (s.attr('random') == 1) ? true : false;
		if(!randomlist) {
			var audiopos = (track_active < (playlists[playlist_id].tracks.length -1) && (typeof init !== 'undefined' && init !== true)) ? (track_active + 1) : 0;
		}
		else {
			var audiopos = Math.floor(Math.random() * playlists[playlist_id].tracks.length);
		}
		find_audio(playlist_name,audiopos);
	}
	// play a single track
	function play_track(playlist,track) {
		// if we're switching too fast kill both tracks first
		if(last_track_switch != 0 && (($.now() - (fade_time * 1000 + 500)) < last_track_switch)) {
			audioplayer['tracka'].pause();
			audioplayer['trackb'].pause();
		}
		last_track_switch = $.now();
		playlist_active_name = playlists[playlist].name;
		playlist_last = playlist_active;
		track_last = track_active;
		$('ul.playlist li').removeClass('active');
		var last_active = playlists[playlist_active].tracks[track_active];
		var equallast = (playlist_last == playlist && track_last == track) ? true : false;
		if(equallast) {
			audioplayer[tape_side].pause();
			audioplayer[last_tape_side].pause();
		}
		last_tape_side = tape_side;
		// first fade out last song
		if(!audioplayer[last_tape_side].paused && !equallast) {
			$(audioplayer[tape_side]).unbind('timeupdate');
			audio_fadeout(last_tape_side,trackvolume);
			track_last_timeout = setTimeout(function(){audioplayer[last_tape_side].pause();audioplayer[last_tape_side].currentTime=0},2100);
		}
		// switch tape side
		tape_side = (tape_side == 'tracka') ? 'trackb' : 'tracka';
		audioplayer[tape_side] = new Audio(playlists[playlist].tracks[track].audio);
		audioplayer_volume[tape_side] = playlists[playlist].tracks[track].volume;
		var current_active = playlists[playlist].tracks[track];
		$('.playlist[listname="'+playlists[playlist].name+'"]').attr('currentpos',track);
		// if same song is repeated, start from beginning
		if(equallast) {
			audioplayer[tape_side].currentTime=0;
		}
		// track song ending
		$(audioplayer[tape_side]).on('ended',function(){
			$('li[audiourl="'+current_active.audio+'"]').removeClass('active');
			play_playlist(playlist_active_name,false);
		});
		// track time
		$(audioplayer[tape_side]).bind('timeupdate',function(){
			var track_totaltime = new Date(this.duration * 1000).toISOString().substr(14, 5);
			var track_currenttime = new Date(this.currentTime * 1000).toISOString().substr(14, 5);
			$('div.musictime > .numbers').text(track_currenttime+' / '+track_totaltime);
			$('div.musictime > .slidebar > div').css('width',((this.currentTime * 100) / this.duration)+'%');
		});
		// set category and name display
		$('div.category').text(playlists[playlist].namenice);
		$('div.title').text(playlists[playlist].tracks[track].name);
		$('ul.playlist').each(function(){
			$(this).removeClass('visible');
			if($(this).attr('listname') == playlist_active_name) {
				$(this).addClass('visible');
			}
		});
		$('div.playlists button').each(function(){
			$(this).removeClass('active');
			if($(this).attr('listname') == playlist_active_name) {
				$(this).addClass('active');
			}
		});
		$('.play').addClass('hidden');
		$('.pause').addClass('visible');
		// fade in and play
		audioplayer[tape_side].play();
		audio_fadein(tape_side,0);
		$('ul.playlist[listname="'+playlist_active_name+'"] li:nth-child('+(track + 1)+')').addClass('active');
		playlist_active = playlist;
		track_active = track;
	}

	// play random from soundlist
	function play_sounds(playlist_name) {
		var s = $('.soundlist[listname="'+playlist_name+'"]');
		var b = $('.btnblock[listname="'+playlist_name+'"]');
		var randomlist = (s.attr('random') == 1) ? true : false;
		var r = (s.attr('repeat') == 1) ? true : false;
		var playlistonce = (s.attr('playlistonce') == 1) ? true : false;
		var rs = s.attr('repeatspeed');
		var sid = s.attr('listname');
		b.parent().addClass('active');
		let audiopos = (randomlist) ? getrandomsound(playlist_name,true) : getnextsound(playlist_name,true);
		let audiourl = getsoundfile(playlist_name,audiopos);
		var audioelm = $("<audio />").addClass('audiosound').attr({'listname':playlist_name,'src':audiourl,'autoplay':'autoplay'}).appendTo("body");
		audioelm.prop('volume',0);
		audioelm.animate({volume: audio_calculatevolume(parseFloat($('.btnblock[listname="'+playlist_name+'"] .volume').html()),getsoundvolume(playlist_name))}, fade_step_sound);
		if(r || playlistonce) {
			// play random on multiple sounds in list
			if(rs > 0 || $('.soundlist[listname="'+playlist_name+'"]').children('li').length > 1) {
				audioelm.on('ended', function() {
					if($.isEmptyObject(soundloops.sid)) {
						soundloops.sid = [];
					}
					let to = setTimeout(function(){resetsound(audioelm,playlist_name,to,randomlist)},rs);
					soundloops.sid.push(to);
					b.find('.stopsound').unbind('click').click(function(){
						stop_sounds(playlist_name,to);
						$(this).blur();
					});
				});
			}
			else {
				// single file in list, use buffer for more seamless replay
				audioelm.on('timeupdate',function() {
					let buffer = .44;
					if($(this)[0].currentTime > $(this)[0].duration - buffer) {
						$(this)[0].currentTime = 0;
						$(this)[0].play();
					}
				});
			}
		}
		else {
			audioelm.on('ended',function() {
				if($('audio[listname="'+playlist_name+'"]').length <= 1) {
					b.parent().removeClass('active');
				}
				$(this).remove();
			});
		}
	}
	function getnextsound(playlist_name,init) {
		let s = $('.soundlist[listname="'+playlist_name+'"]');
		var ignorecount = (s.attr('playlistonce') == 1) ? true : false;
		let rc = (typeof soundlast[playlist_name] !== 'undefined' && (init !== true || ignorecount !== true)) ? (soundlast[playlist_name] + 1) : 0;
		if(rc >= s.children('li').length) {
			rc = 0;
		}
		if(!init && rc == 0) {
			return -1;
		}
		soundlast[playlist_name] = rc;
		return rc;
	}
	function getrandomsound(playlist_name,init) {
		let s = $('.soundlist[listname="'+playlist_name+'"]');
		let rc = Math.floor(Math.random()*s.children('li').length);
		let c = (typeof soundlast[playlist_name] !== 'undefined' && init !== true) ? (soundlast[playlist_name] + 1) : 0;
		if(!init && c >= s.children('li').length) {
			return -1;
		}
		soundlast[playlist_name] = c;
		return rc;
	}
	function getsoundfile(playlist_name,pos) {
		let s = $('.soundlist[listname="'+playlist_name+'"]');
		s.attr('currentpos',pos);
		if(pos < 0) {
			return -1;
		}
		let a = s.children('li').eq(pos);
		return a.attr('audiourl');
	}
	function getsoundvolume(playlist_name) {
		let s = $('.soundlist[listname="'+playlist_name+'"]');
		let pos = s.attr('currentpos');
		if(pos < 0) {
			return 0;
		}
		let a = s.children('li').eq(pos);
		return a.attr('volume');
	}
	function removesoundtimeout(to) {
		clearTimeout(to);
		let iv = soundloops.sid.indexOf(to);
		if(iv > -1) {
			soundloops.sid.splice(iv, 1);
		}
	}
	function resetsound(elm,playlist,to,randomlist) {
		removesoundtimeout(to);
		// get random sound from list and play
		var s = $('.soundlist[listname="'+playlist+'"]');
		var ignorecount = (s.attr('playlistonce') == 1) ? false : true;
		let audiopos = (randomlist) ? getrandomsound(playlist,ignorecount) : getnextsound(playlist,ignorecount);
		let audiourl = getsoundfile(playlist,audiopos);
		if(audiourl != -1) {
			elm[0].src = audiourl;
			elm[0].currentTime = 0;
			elm[0].volume = audio_calculatevolume(parseFloat($('.btnblock[listname="'+playlist+'"] .volume').html()),getsoundvolume(playlist));
			elm[0].play();
		}
		else {
			stop_sounds(playlist,to);
		}
	}
	function clearsoundloops(timeout) {
		if(typeof timeout !== 'undefined' && timeout != 'all') {
			removesoundtimeout(timeout);
		}
		else {
			// remove all
			if(!$.isEmptyObject(soundloops.sid)) {
				$.each(soundloops.sid,function(i,v){
					removesoundtimeout(v);
				});
			}
		}
	}
	function stop_sounds(playlist_name,timeout) {
		if(typeof timeout !== 'undefined') {
			clearsoundloops(timeout);
		}
		$('audio.audiosound[listname="'+playlist_name+'"]').unbind();
		$('audio.audiosound[listname="'+playlist_name+'"]').animate({volume: 0}, fade_step_sound, function(){$(this).remove();});
		$('.btnblock[listname="'+playlist_name+'"]').parent().removeClass('active');
	}
	function sounds_volume(playlist_name,dir) {
		var vol = parseFloat($('.btnblock[listname="'+playlist_name+'"] .volume').html());
		let currentvolume = getsoundvolume(playlist_name);
		vol = (dir == 'up') ? ((vol < 1) ? vol+.1 : 1) : ((vol > 0) ? vol-.1 : 0);
		vol = vol.toFixed(1);
		$('audio.audiosound[listname="'+playlist_name+'"]').prop('volume',audio_calculatevolume(vol,currentvolume));
		$('.btnblock[listname="'+playlist_name+'"] .volume').html(vol);
	}
	// stop all sounds at once
	function stopallsounds() {
		$('audio.audiosound').each(function() {
			$(this).remove();
		});
		$('.soundlists .soundblock').removeClass('active');
		clearsoundloops('all');
	}

	// fade in and out
	function audio_fadein(player,vol) {
		if(vol <= 1 && vol <= trackvolume) {
			audioplayer[player].volume = audio_calculatevolume(vol,audioplayer_volume[player]);
			setTimeout(function(){audio_fadein(player,(vol+0.05));},fade_step);
		}
	}
	function audio_fadeout(player,vol) {
		if(vol >= 0) {
			audioplayer[player].volume = audio_calculatevolume(vol,audioplayer_volume[player]);
			setTimeout(function(){audio_fadeout(player,(vol-0.05));},fade_step);
		}
		else {
			audioplayer[player].pause();
		}
	}
	function audio_volume(dir) {
		trackvolume = (dir == 'up') ? ((trackvolume < 1) ? trackvolume+.1 : 1) : ((trackvolume > 0) ? trackvolume-.1 : 0);
		audioplayer['tracka'].volume = audio_calculatevolume(trackvolume,audioplayer_volume['tracka']);
		audioplayer['trackb'].volume = audio_calculatevolume(trackvolume,audioplayer_volume['trackb']);
		$('.currentvolume').html(trackvolume.toFixed(1));
	}
	function audio_calculatevolume(g,v) {
		if(isNaN(g)) {
			g = 1;
		}
		if(isNaN(v)) {
			v = 1;
		}
		return (parseFloat(g) * parseFloat(v));
	}

	// find audio in list
	function find_audio(playlistname,audiopos) {
		var playlist_id = 0;
		var track_id = 0;
		for(var i=0;i<playlists.length;i++) {
			if(playlists[i].name == playlistname) {
				playlist_id = i;
				play_track(playlist_id,audiopos);
				return;
			}
		}
		console.log("not found: "+playlistname+", "+trackname);
	}
	// play and stop playback
	function playmusic() {
		audioplayer[tape_side].play();
		audioplayer[tape_side].volume = trackvolume;
		$('.play').addClass('hidden');
		$('.pause').addClass('visible');
	}
	function stopmusic() {
		audioplayer['tracka'].pause();
		audioplayer['trackb'].pause();
		$('.play').removeClass('hidden');
		$('.pause').removeClass('visible');
	}

});
