// remote modules
var remote = require('electron').remote;
var dialog = require('electron').remote.dialog;
var app = require('electron').remote.app;
var fs = require('fs');
var configfilepath = app.getPath('userData')+'/config.json';
var configdata = {'language':'de','layout':'desktop','musicpathfind':'','musicpathreplace':'','soundpathfind':'','soundpathreplace':'','startcounter':0,'updatereminder':1};
var configdata_reset = configdata;

jQuery(document).ready(function() {
	fs.readFile(configfilepath, 'utf-8', (err, data) => {
		if(!err && typeof languageselectpage === 'undefined') {
			configdata = {...configdata,...JSON.parse(data)};
		}
		else if(!err && typeof languageselectpage !== 'undefined') {
			window.location.href = 'index.html';
		}
		else if(typeof languageselectpage === 'undefined') {
			window.location.href = 'index_languageselect.html';
		}
		loadpage();
	});
	$.fn.rpgaudio_checkversion = function(showresult) {
		var resulttext = '';
		// check version
		$.ajax({
			type: 'GET',
			url: 'https://rpgaudioplayer.khuris.com/version.txt?'+new Date().getTime(),
			success: function(d) {
				resulttext = (d != '' && d != app.getVersion()) ? langstrings.version_new.replace(/%s/g,d) : langstrings.version_uptodate;
				if((typeof showresult !== 'undefined' && showresult == true) || (d != '' && d != app.getVersion())) {
					$.fn.rpgaudio_printversioncheck(resulttext);
				}
			},
			error: function() {
				resulttext = langstrings.version_uptodate;
				if(typeof showresult !== 'undefined' && showresult == true) {
					$.fn.rpgaudio_printversioncheck(resulttext);
				}
			}
		});
		return this;
	}
	$.fn.rpgaudio_printversioncheck = function(resulttext) {
		$('body').append($('<div id="updatereminder"><div class="close"><em class="fa fa-times-circle"></em></div><div class="text"></div><p class="url"><a href="https://rpgaudioplayer.khuris.com/" target="_blank"><em class="fa fa-external-link"></em>rpgaudioplayer.khuris.com</a></p></div>'));
		$('#updatereminder .close').click(function(){
			$(this).parent().remove();
		});
		$('#updatereminder .text').html(resulttext);
		return this;
	}

	function loadpage() {
		// load language file
		$.getScript('playerlang_'+configdata.language+'.js',function(){
			// load small layout
			if(configdata.layout == 'laptop') {
				$('<link />', {rel:'stylesheet', type:'text/css', href:'main_laptop.css'}).appendTo('head');
			}
			// language
			if($('#navigation').length || $('body#index').length) {
				let elm = ($('#navigation').length) ? $('#navigation') : $('.mainmenu');
				elm.append('<a href="index_player.html" id="nav_player" title="'+langstrings.nav_player+'"><i class="fa fa-play-circle"></i></a>');
				elm.append('<a href="index_setup.html" id="nav_setup" title="'+langstrings.nav_setup+'"><i class="fa fa-plus-circle"></i></a>');
				elm.append('<a href="index_info.html" id="nav_about" title="'+langstrings.nav_info+'"><i class="fa fa-question-circle"></i></a>');
			}
			if($('body.info').length) {
				$('#info').append(langstrings.tab_info);
				$('#setup').append(langstrings.tab_setup);
				$('h2.language').append(langstrings.info_language);
				$('.language_selection .lang-de').append(langstrings.language_de);
				$('.language_selection .lang-en').append(langstrings.language_en);
				$('h2.layout').append(langstrings.layout);
				$('.layout_selection .layout-desktop').append(langstrings.layout_desktop);
				$('.layout_selection .layout-laptop').append(langstrings.layout_laptop);
				$('h2.version').append(langstrings.version);
				$('div.version').append($('<p />').html(langstrings.version_alt));
				$('h2.paths').append(langstrings.paths);
				$('.musicpath').append(langstrings.musicpath);
				$('.soundpath').append(langstrings.soundpath);
				$('#musicfind, #soundfind').append(langstrings.pathfind);
				$('#musicreplace, #soundreplace').append(langstrings.pathreplace);
				$('.paths_info').append(langstrings.paths_info);
				$('.resetconfig').append(langstrings.resetconfig);
				$('.updatecheck').append(langstrings.updatecheck);
				$('.versioncheckbtn').append(langstrings.versioncheckbtn);
			}
			if($('.mainmenu').length) {
				configdata.startcounter++;
				changeconfig(configdata.startcounter,'startcounter');
				if(configdata.startcounter == 10) {
					$('#supportreminder').addClass('showinfo').append(langstrings.supportreminder);
					$('#supportreminder .close').click(function(){
						$('#supportreminder').removeClass('showinfo');
					});
				}
				if(configdata.updatereminder == 1) {
					$.fn.rpgaudio_checkversion(false);
				}
				$('.mainmenu #nav_player').addClass('btn full').append(langstrings.nav_player);
				$('.mainmenu #nav_setup').addClass('btn full').append(langstrings.nav_setup);
				$('.mainmenu #nav_about').addClass('btn full').append(langstrings.nav_info);
				$('.language_selection .lang-de').append(langstrings.language_de);
				$('.language_selection .lang-en').append(langstrings.language_en);
				$('.language_selection > .btn').click(function(){
					changeconfig($(this).attr('data-lang'),'language');
				});
			}
			if($('body.setup').length) {
				$('.setup_title1').append(langstrings.setup_title1);
				$('#save_scenario').append(langstrings.btn_save_scenario);
				$('#load_scenario').append(langstrings.btn_load_scenario);
				$('#new_scenario').append(langstrings.btn_new_scenario);
				$('.new_playlist').append(langstrings.btn_playlist);
				$('.new_dynplaylist').append(langstrings.btn_dynplaylist);
				$('.new_block').append(langstrings.btn_block);
				$('.new_soundblock').append(langstrings.btn_block);
				$('.new_soundlist').append(langstrings.btn_soundlist);
				$('.new_dynsoundlist').append(langstrings.btn_dynsoundlist);
				$('.expandlist').append(langstrings.expandlist);
			}
			if($('body.player').length) {
				$('#load_scenario').append(langstrings.btn_load_scenario);
				$('#new_scenario').append(langstrings.btn_new_scenario);
				$('#title_player').append(langstrings.title_player);
				$('#tab1').append(langstrings.music);
				$('#tab2').append(langstrings.playlist);
				$('#tab3').append(langstrings.sounds);
				$('#stopsounds').attr('title',langstrings.btn_stopall);
			}
			$('#music').append(langstrings.music);
			$('#sounds').append(langstrings.sounds);
			$('.pagefoot').html('<p>'+langstrings.pagefoot+'</p>');

			// load additional files
			if($('body.player').length) {
				$.getScript('player.js');
			}
			else if($('body.setup').length) {
				$.getScript('playersetup.js');
			}
			else if($('body.info').length) {
				$.getScript('playerinfo.js');
			}
		});
	}

	$.extend($.fn.disableTextSelect = function() {
		return this.each(function(){
			$(this).mousedown(function(){return false;});
		});
	});
});

// functions
function changeconfig(data,type,resetconfig) {
	if(type == 'language') {
		configdata.language = data;
	}
	else if(type == 'layout') {
		configdata.layout = data;
	}
	else if(type == 'startcounter') {
		configdata.startcounter = data;
	}
	else if(type == 'updatereminder') {
		configdata.updatereminder = data;
	}
	else {
		data = data.replace(/Benutzer\\(.*?)\\Dokumente/i, "users\\$1\\documents");
		configdata[type] = data;
	}
	if(resetconfig === true) {
		configdata = configdata_reset;
	}
	let content = JSON.stringify(configdata);
	fs.writeFile(configfilepath, content, (err) => {
		if(err) {
			alert("An error ocurred updating the file" + err.message);
			return;
		}
	});
	if(type == 'language') {
		window.location.href = 'index.html';
	}
	else if(type == 'layout') {
		window.location.href = 'index_player.html';
	}
	if(resetconfig === true) {
		window.location.href = 'index.html';
	}
}
function csvtext(v) {
	return '"'+v.replace(/;/g, "\\;").replace(/"/g, '\\"')+'"';
}
function csvcombine(a) {
	var csv = '';
	$.each(a,function(i,v){
		csv += v+"\n";
	});
	return csv;
}
function splitfile(f) {
	let filename = f.match(/\\([^\\]*)$/);
	return {name:filename[1],path:f};
}
function cleartext(v) {
	return v.replace(/^"|"$/g, "");
}