// remote modules
var basepath = app.getAppPath();
var path = require('path');
// sound preview
var sound = new Audio();
sound.volume = 1;
// vars
var changesmade = false;
var listexpanded = false;
var volumes = {1:'100%',0.9:'90%',0.8:'80%',0.7:'70%',0.6:'60%',0.5:'50%',0.4:'40%',0.3:'30%',0.2:'20%',0.1:'10%',0:'0%'};
var repeattimes = {none:langstrings.no_repeat,once:langstrings.repeat_once,0:langstrings.repeat,5:'5s',10:'10s',15:'15s',30:'30s',60:'60s',90:'1m 30s',120:'2m',300:'5m',600:'10m'};
var colors = ['#2c2c2e','#212631','#f44336','#9c27b0','#3f51b5','#009688','#4caf50','#ffc107','#ff5722','#607d8b','#795548','#616161'];
// icon list
var rpgicons = ['fa fa-music','fa fa-anchor','fa fa-bed','fa fa-beer','fa fa-bell','fa fa-bomb','fa fa-book','fa fa-bug','fa fa-bullhorn','fa fa-car','fa fa-coffee','fa fa-compass','fa fa-diamond','fa fa-eye','fa fa-fire','fa fa-flash','fa fa-heart','fa fa-hourglass-half','fa fa-laptop','fa fa-map-o','fa fa-microphone','fa fa-microchip','fa fa-plane','fa fa-plug','fa fa-shield','fa fa-snowflake-o','fa fa-superpowers','fa fa-thermometer-half','fa fa-tree','fa fa-umbrella','fa fa-unlock','fa fa-users','fa fa-wifi','fa fa-wrench'];
// available keyboard keys
var keyboardkeyslist = {0:'',48:'0',49:'1',50:'2',51:'3',52:'4',53:'5',54:'6',55:'7',56:'8',57:'9',97:'A',98:'B',99:'C',100:'D',101:'E',102:'F',103:'G',104:'H',105:'I',106:'J',107:'K',108:'L',109:'M',110:'N',111:'O',112:'P',113:'Q',114:'R',115:'S',116:'T',117:'U',118:'V',119:'W',120:'X',121:'Y',122:'Z'};
var currentkeys = [];

jQuery(document).ready(function() {

	// make tabs
	$('#music').click(function(){
		if(!$('#music').hasClass('active')) {
			$('#music').addClass('active');
			$('#sounds').removeClass('active');
			$('#playlistbox').addClass('visible');
			$('#soundlistbox').removeClass('visible');
		}
	});
	$('#sounds').click(function(){
		if(!$('#sounds').hasClass('active')) {
			$('#sounds').addClass('active');
			$('#music').removeClass('active');
			$('#playlistbox').removeClass('visible');
			$('#soundlistbox').addClass('visible');
		}
	});

	$('#playlists, #soundlists').sortable({
		handle: ".headtable .handler",
		forceHelperSize: true,
		items: " > div",
		placeholder: "sortable-placeholder",
		opacity: 0.5,
		containment: "document",
		axis: "y",
		start: function(e,ui) {
			ui.helper.height('41px');
		},
		change: function(e,ui){
			changesmade = true;
		}
	});
	$('.new_playlist').click(function(){
		createplaylist();
	});
	$('.new_dynplaylist').click(function(){
		createplaylist('','','',false,1,1);
	});
	$('.new_block').click(function(){
		createblock('',$('#playlists'));
	});
	$('.new_soundlist').click(function(){
		createsoundlist();
	});
	$('.new_dynsoundlist').click(function(){
		createsoundlist('','','',1,'none',false,1,1);
	});
	$('.new_soundblock').click(function(){
		createblock('',$('#soundlists'));
	});
	$('.expandlist').click(function(){
		if(listexpanded) {
			$('.expandlist i').removeClass('fa-minus-square-o').addClass('fa-plus-square-o');
			$('.togglebtn').addClass('fa-flip-vertical');
			$('.fileouterbox').css('display','none');
			listexpanded = false;
		}
		else {
			$('.expandlist i').removeClass('fa-plus-square-o').addClass('fa-minus-square-o');
			$('.togglebtn').removeClass('fa-flip-vertical');
			$('.fileouterbox').css('display','block');
			listexpanded = true;
		}
	});

	function createblock(name,group) {
		changesmade = true;
		let outerbox = $('<div class="outerblock block" />');
		let headbox = $('<div class="headtable" />');
		let handler = $('<div class="handler" />');
		handler.append($('<i class="fa fa-reorder" />'));
		let deletebtn = $('<div class="deletebtn" />');
		deletebtn.append($('<i class="fa fa-remove" />'));
		deletebtn.click(function(){
			changesmade = true;
			$(this).parents('.outerblock').remove();
		});
		let listname = $('<input type="text" name="block[]" value="'+((typeof name !== 'undefined') ? name : '')+'" placeholder="'+langstrings.title+'" />');
		group.append(outerbox.append(headbox.append(deletebtn).append(handler).append(listname)));
		listname.focus();
	}
	function createplaylist(name,color,icon,openclosed,randomlist,dynfolder,keyboardkey) {
		changesmade = true;
		var openclosed = (typeof openclosed !== 'undefined' && openclosed !== false) ? true : false;
		let outerbox = $('<div class="outerblock playlist" />');
		let headbox = $('<div class="headtable" />');
		let handler = $('<div class="handler" />');
		handler.append($('<i class="fa fa-reorder" />'));
		let deletebtn = $('<div class="deletebtn" />');
		deletebtn.append($('<i class="fa fa-remove" />'));
		deletebtn.click(function(){
			let c = confirm(langstrings.delete_verify);
			if(c) {
				changesmade = true;
				$(this).parents('.outerblock').remove();
			}
			return true;
		});
		let togglebtn = $('<div class="togglebtn'+((openclosed) ? ' fa-flip-vertical' : '')+'" />');
		togglebtn.append($('<i class="fa fa-chevron-down" />'));
		togglebtn.click(function(){
			$(this).parents('.outerblock').children('.fileouterbox').toggle();
			$(this).toggleClass('fa-flip-vertical');
		});
		if(typeof color === 'undefined') {
			color = '#2c2c2e';
		}
		let listname = $('<input type="text" name="playlist[]" value="'+((typeof name !== 'undefined') ? name : '')+'" style="background-color:'+color+'" placeholder="'+langstrings.title+'" />');
		let listcolor = createcolorlist(color,'playlistcolor');
		let iconpicker = $('<input name="playlisticon[]" class="iconpicker"></select>');
		let randompick = createrandompick(randomlist,'playlistrandom');
		let keyboardpick = createkeyboardkeyselect(keyboardkey,'playlistkey');
		let listdyn = $('<input name="playlistdyn[]" class="hidden" value="'+((typeof dynfolder !== 'undefined' && dynfolder == '1') ? 1 : 0)+'">');
		outerbox.append(headbox.append(deletebtn).append(handler).append(togglebtn).append(listname).append(listcolor).append(iconpicker).append(randompick).append(keyboardpick).append(listdyn));
		let fileouterbox = $('<div class="fileouterbox"'+((openclosed) ? ' style="display:none;"' : '')+' />');
		let filebox = $('<div class="filebox" />');
		let filenewbox = $('<div class="filenewbox" />');
		if(typeof dynfolder !== 'undefined' && dynfolder == '1') {
			var newfile = $('<label class="btn full"><i class="fa fa-plus-circle"></i>'+langstrings.newfolder+'<input type="file" webkitdirectory class="hidden"></label>');
		}
		else {
			var newfile = $('<label class="btn full"><i class="fa fa-plus-circle"></i>'+langstrings.newfile+'<input type="file" multiple="multiple" class="hidden" accept=".wav,.mp3,.ogg,.oga,.webm"></label>');
		}
		filenewbox.append(newfile);
		fileouterbox.append(filebox).append(filenewbox);
		outerbox.append(fileouterbox);
		$('#playlists').append(outerbox);
		// init functions
		$('#playlists .playlist:last-child .iconpicker').fontIconPicker({
			theme: 'fip-inverted',
			iconsPerPage: 50,
			hasSearch: false,
			source: rpgicons,
			useAttribute: true,
			attributeName: 'class',
			convertToHex: false,
		});
		if(typeof icon !== 'undefined' && icon != '') {
			seticonpick($('#playlists .playlist:last-child .icons-selector'),icon);
		}
		$('#playlists .playlist:last-child .filebox').sortable({
			handle: ".handler",
			forceHelperSize: true,
			items: " > .file",
			placeholder: "sortable-placeholder",
			opacity: 0.5,
			containment: "document",
			axis: "y",
			change: function(){
				changesmade = true;
			}
		});
		iconpicker.val(icon);
		listname.focus();
		if(typeof dynfolder !== 'undefined' && dynfolder == '1') {
			$('#playlists .playlist:last-child .filenewbox input[type="file"]').change(function(){folderselect($(this))});
		}
		else {
			$('#playlists .playlist:last-child .filenewbox input[type="file"]').change(function(){fileselect($(this))});
		}
	}
	function createsoundlist(name,color,icon,volume,repeattime,openclosed,randomlist,dynfolder,keyboardkey) {
		changesmade = true;
		var openclosed = (typeof openclosed !== 'undefined' && openclosed !== false) ? true : false;
		let outerbox = $('<div class="outerblock soundlist" />');
		let headbox = $('<div class="headtable" />');
		let handler = $('<div class="handler" />');
		handler.append($('<i class="fa fa-reorder" />'));
		let deletebtn = $('<div class="deletebtn" />');
		deletebtn.append($('<i class="fa fa-remove" />'));
		deletebtn.click(function(){
			let c = confirm(langstrings.delete_verify);
			if(c) {
				changesmade = true;
				$(this).parents('.outerblock').remove();
			}
			return true;
		});
		let togglebtn = $('<div class="togglebtn'+((openclosed) ? ' fa-flip-vertical' : '')+'" />');
		togglebtn.append($('<i class="fa fa-chevron-down" />'));
		togglebtn.click(function(){
			$(this).parents('.outerblock').children('.fileouterbox').toggle();
			$(this).toggleClass('fa-flip-vertical');
		});
		if(typeof color === 'undefined') {
			color = '#2c2c2e';
		}
		let listname = $('<input type="text" name="soundlist[]" value="'+((typeof name !== 'undefined') ? name : '')+'" style="background-color:'+color+'" placeholder="'+langstrings.title+'" />');
		let listcolor = createcolorlist(color,'soundlistcolor');
		let iconpicker = $('<input name="soundlisticon[]" class="iconpicker"></select>');
		let randompick = createrandompick(randomlist,'soundlistrandom');
		let volumepicker = createvolume(volume);
		let repeatpicker = createrepeat(repeattime);
		let keyboardpick = createkeyboardkeyselect(keyboardkey,'soundkey');
		let listdyn = $('<input name="soundlistdyn[]" class="hidden" value="'+((typeof dynfolder !== 'undefined' && dynfolder == '1') ? 1 : 0)+'">');
		outerbox.append(headbox.append(deletebtn).append(handler).append(togglebtn).append(listname).append(listcolor).append(iconpicker).append(randompick).append(volumepicker).append(repeatpicker).append(keyboardpick).append(listdyn));
		let fileouterbox = $('<div class="fileouterbox""'+((openclosed) ? ' style="display:none;"' : '')+' />');
		let filebox = $('<div class="filebox" />');
		let filenewbox = $('<div class="filenewbox" />');
		if(typeof dynfolder !== 'undefined' && dynfolder == '1') {
			var newfile = $('<label class="btn full"><i class="fa fa-plus-circle"></i>'+langstrings.newfolder+'<input type="file" webkitdirectory class="hidden"></label>');
		}
		else {
			var newfile = $('<label class="btn full"><i class="fa fa-plus-circle"></i>'+langstrings.newsound+'<input type="file" multiple="multiple" class="hidden" accept=".wav,.mp3,.ogg,.oga,.webm"></label>');
		}
		filenewbox.append(newfile);
		fileouterbox.append(filebox).append(filenewbox);
		outerbox.append(fileouterbox);
		$('#soundlists').append(outerbox);
		// init functions
		$('#soundlists .soundlist:last-child .iconpicker').fontIconPicker({
			theme: 'fip-inverted',
			iconsPerPage: 50,
			hasSearch: false,
			source: rpgicons,
			useAttribute: true,
			attributeName: 'class',
			convertToHex: false,
		});
		if(typeof icon !== 'undefined' && icon != '') {
			seticonpick($('#soundlists .soundlist:last-child .icons-selector'),icon);
		}
		$('#soundlists .soundlist:last-child .filebox').sortable({
			handle: ".handler",
			forceHelperSize: true,
			items: " > .file",
			placeholder: "sortable-placeholder",
			opacity: 0.5,
			containment: "document",
			axis: "y",
			change: function(){
				changesmade = true;
			}
		});
		iconpicker.val(icon);
		listname.focus();
		if(typeof dynfolder !== 'undefined' && dynfolder == '1') {
			$('#soundlists .soundlist:last-child .filenewbox input[type="file"]').change(function(){folderselect($(this))});
		}
		else {
			$('#soundlists .soundlist:last-child .filenewbox input[type="file"]').change(function(){fileselect($(this))});
		}
	}
	function seticonpick(elm,pick) {
		changesmade = true;
		elm.find('.selected-icon').empty().append('<i class="'+pick+'" />');
		elm.find('.fip-icons-container .fip-box').removeClass('current-icon');
		elm.find('.fip-icons-container .fip-box[title="'+pick+'"]').addClass('current-icon');
	}
	function createcolorlist(color,listname) {
		if(typeof color === 'undefined') {
			color = '#2c2c2e';
		}
		let label = $('<label class="fa fa-paint-brush" />');
		let box = $('<select name="'+listname+'[]" style="background-color:'+color+'" class="colorpicker"></select>');
		$.each(colors,function(i,v){
			box.append($('<option value="'+v+'" style="background-color:'+v+'"'+((color == v) ? ' selected="selected"' : '')+'></option>'));
		});
		box.change(function(){
			$(this).css('background-color',$(this).val());
			$(this).parents('.headtable').children('input').css('background-color',$(this).val());
			$(this).parents('.headtable').children('input').focus();
		});
		label.append(box);
		return label;
	}
	function createrandompick(pick,listname) {
		if(typeof pick === 'undefined') {
			pick = 1;
		}
		let label = $('<label class="fa fa-list" />');
		let box = $('<select name="'+listname+'[]" class="randompick"></select>');
		$.each({'1':'f074','0':'f160'},function(i,v){
			box.append($('<option value="'+i+'"'+((pick == i) ? ' selected="selected"' : '')+'>&#x'+v+';</option>'));
		});
		label.append(box);
		return label;
	}
	function createkeyboardkeyselect(pick,listname) {
		if(typeof pick === 'undefined') {
			pick = 0;
		}
		let label = $('<label class="fa fa-caret-square-o-down" />');
		let box = $('<select name="'+listname+'[]" class="keyboardkey" data-val="'+((pick != 0) ? pick : 0)+'"></select>');
		$.each(keyboardkeyslist,function(i,v){
			box.append($('<option value="'+i+'"'+((pick == i) ? ' selected="selected"' : '')+((pick == i || $.inArray(i,currentkeys) != -1) ? ' disabled="disabled"' : '')+'>'+v+'</option>'));
			if(pick == 1) {
				currentkeys.push(pick);
			}
		});
		box.change(function(){
			var ov = $(this).attr('data-val');
			var cv = $(this).val();
			$('select.keyboardkey').find('option[value="'+ov+'"]').attr('disabled',false);
			currentkeys = jQuery.grep(currentkeys, function(cv) {
				return cv != ov;
			});
			$('select.keyboardkey').find('option[value="'+cv+'"]').attr('disabled',true);
			$(this).attr('data-val', cv);
		});
		label.append(box);
		return label;
	}
	function createvolume(vol) {
		if(typeof vol === 'undefined') {
			vol = 1;
		}
		let label = $('<label class="fa fa-volume-up" />');
		let box = $('<select name="soundvolume[]" class="volumepicker"></select>');
		$.each(volumes,function(i,v){
			box.append($('<option value="'+i+'"'+((vol == i) ? ' selected="selected"' : '')+'>'+v+'</option>'));
		});
		label.append(box);
		return label;
	}
	function createfilevolume(vol) {
		if(isNaN(vol) || typeof vol === 'undefined') {
			vol = 1;
		}
		let label = $('<label class="fa fa-volume-up" />');
		let box = $('<select name="filevolume[]" class="filevolumepicker"></select>');
		$.each(volumes,function(i,v){
			box.append($('<option value="'+i+'"'+((vol == i) ? ' selected="selected"' : '')+'>'+v+'</option>'));
		});
		box.on('change',function(){
			if(!$(this).parents('.file').children('.playbtn').children('.fa-pause-circle').hasClass('hidden')) {
				changevolume($(this).val());
			}
		})
		label.append(box);
		return label;
	}
	function createrepeat(repeattime) {
		if(typeof repeattime === 'undefined') {
			repeattime = 'none';
		}
		let label = $('<label class="fa fa-repeat" />');
		let box = $('<select name="soundrepeat[]" class="repeatpicker"></select>');
		$.each(repeattimes,function(i,v){
			box.append($('<option value="'+i+'"'+((repeattime == i) ? ' selected="selected"' : '')+'>'+v+'</option>'));
		});
		label.append(box);
		return label;
	}
	function fileappend(parentbox,file,vol) {
		changesmade = true;
		let relativepath = path.relative(path.dirname(basepath),path.dirname(file.path));
		if(!path.isAbsolute(relativepath)) {
			relativepath = '..'+path.sep+relativepath;
		}
		let fbox = $('<div class="file" />');
		let fname = $('<div class="filename">'+file.name+'</div>');
		let finput = $('<input type="hidden" name="filename[]" value="'+relativepath+'\\'+file.name+'">');
		let handler = $('<div class="handler" />');
		handler.append($('<i class="fa fa-reorder" />'));
		let deletebtn = $('<div class="deletebtn" />');
		deletebtn.append($('<i class="fa fa-remove" />'));
		deletebtn.click(function(){
			changesmade = true;
			if(!$(this).parents('.file').children('.playbtn').children('.fa-pause-circle').hasClass('hidden')) {
				stopsound();
			}
			$(this).parents('.file').remove();
		});
		let playbtn = $('<div class="playbtn" />');
		playbtn.append($('<i class="fa fa-play-circle" /><i class="fa fa-pause-circle hidden" />'));
		playbtn.click(function(){
			playsound($(this).parents('.file').children('input[name="filename[]"]'),$(this),$(this).parents('.file').find('select[name="filevolume[]"]').val());
		});
		let volumebtn = $('<div class="volumebtn" />');
		volumebtn.append(createfilevolume(vol));
		fbox.append(fname).append(deletebtn).append(finput).append(handler).append(playbtn).append(volumebtn);
		parentbox.append(fbox);
	}
	function fileselect(f) {
		if(f[0] && f[0].files) {
			let parentbox = f.parents('.outerblock').find('.filebox');
			let files = f[0].files;
			if(files.length > 0) {
				for(let i=0;i<files.length;i++) {
					let result = files[i].path.match(/\.([a-z0-9]*)$/ig);
					if(result !== null && result[0] && $.inArray(result[0],['.wav','.mp3','.ogg','.oga','.webm']) !== -1) {
						fileappend(parentbox,files[i],1);
					}
					else {
						alert(langstrings.invalidfile.replace(/%s/g, files[i].name));
					}
				}
				$('#playlists .playlist:last-child .filenewbox input[type="file"]').val('');
				$('#soundlists .soundlist:last-child .filenewbox input[type="file"]').val('');
			}
		}
	}
	function folderappend(parentbox,file) {
		let fbox = $('<div class="file" />');
		let fname = $('<div class="filename">'+langstrings.folderloaded.replace(/%s/g, file)+'</div>');
		let finput = $('<input type="hidden" name="filename[]" value="'+file+'">');
		fbox.append(fname).append(finput);
		parentbox.append(fbox);
	}
	function folderselect(f) {
		if(f[0] && f[0].files) {
			let parentbox = f.parents('.outerblock').find('.filebox');
			parentbox.html('');
			let files = f[0].files;
			if(files.length > 0) {
				for(let i=0;i<files.length;i++) {
					folderappend(parentbox,files[i].path);
				}
			}
		}
	}
	function playsound(f,p,v) {
		sound.pause();
		$('.slidebar').remove();
		if(p.children('.fa-pause-circle').hasClass('hidden')) {
			sound = new Audio(f[0].value);
			sound.play();
			sound.volume = parseFloat(v);
			// switch buttons on sound preview end
			sound.addEventListener('ended',function(){
				$('.fa-play-circle').removeClass('hidden');
				$('.fa-pause-circle').addClass('hidden');
			});
			$('.fa-play-circle').removeClass('hidden');
			$('.fa-pause-circle').addClass('hidden');
			p.children('.fa-play-circle').addClass('hidden');
			p.children('.fa-pause-circle').removeClass('hidden');
			let slidebar = $('<div class="slidebar" />');
			slidebar.append($('<div />'));
			p.parent().append(slidebar);
			slidebar.click(function(e){
				let sc = e.offsetX / $(this).width();
				sound.currentTime = sound.duration * sc;
			});
			sound.removeEventListener('timeupdate',sliderupdate);
			sound.addEventListener('timeupdate',sliderupdate);
		}
		else {
			p.children('.fa-play-circle').removeClass('hidden');
			p.children('.fa-pause-circle').addClass('hidden');
		}
	}
	function stopsound() {
		sound.pause();
	}
	function changevolume(v) {
		sound.volume = parseFloat(v);
	}

	function purgelists() {
		sound.pause();
		$('#playlists').empty();
		$('#soundlists').empty();
		changesmade = false;
	}
	function sliderupdate() {
		$('.slidebar > div').css('width',((this.currentTime * 100) / this.duration)+'%');
	}

	$('#new_scenario').click(function(){
		if(!changesmade || confirm(langstrings.confirm_new)) {
			purgelists();
		}
	});
	$('#load_scenario').click(function(){
		if(!changesmade || confirm(langstrings.confirm_new)) {
			dialog.showOpenDialog((filenames) => {
				if(filenames === undefined){
					return;
				}
				// prepare find paths for replacement
				configdata.musicpathfind = configdata.musicpathfind.replace(/\\/ig, '\\\\');
				configdata.soundpathfind = configdata.soundpathfind.replace(/\\/ig, '\\\\');
				fs.readFile(filenames[0], 'utf-8', (err, data) => {
					if(err){
						alert(langstrings.error_loadfile + err.message);
						return;
					}
					var filemode = '';
					var loadfolder = false;
					var lastlist = false;
					// split lines
					let lines = data.split(/\r?\n/);
					if(lines !== undefined && lines.length > 0) {
						purgelists();
						$.each(lines,function(i,line){
							let blocks = line.trim().split(/(?<!\\);/);
							if(line != '' && blocks !== undefined && blocks.length > 0) {
								if($.inArray(blocks[0],['music','sounds']) !== -1) {
									filemode = blocks[0];
								}
								if(filemode == 'music') {
									if(blocks[0] == 'block') {
										createblock(cleartext(blocks[1]),$('#playlists'));
									}
									if(blocks[0] == 'playlist') {
										loadfolder = (blocks[5] == 1) ? true : false;
										if(blocks[6] > 0) {
											currentkeys.push(blocks[6]);
										}
										createplaylist(cleartext(blocks[1]),blocks[2],blocks[3],true,blocks[4],blocks[5],blocks[6]);
										lastlist = $('#playlists .playlist:last-child .filebox');
									}
								}
								else if (filemode == 'sounds') {
									if(blocks[0] == 'block') {
										createblock(cleartext(blocks[1]),$('#soundlists'));
									}
									if(blocks[0] == 'soundlist') {
										loadfolder = (blocks[7] == 1) ? true : false;
										if(blocks[8] > 0) {
											currentkeys.push(blocks[8]);
										}
										createsoundlist(cleartext(blocks[1]),blocks[2],blocks[3],blocks[4],blocks[5],true,blocks[6],blocks[7],blocks[8]);
										lastlist = $('#soundlists .soundlist:last-child .filebox');
									}
								}
								if(blocks[0] == 'file') {
									if(filemode == 'music') {
										let r = new RegExp(configdata.musicpathfind,'i');
										blocks[1] = blocks[1].replace(r,configdata.musicpathreplace);
									}
									else {
										let r = new RegExp(configdata.soundpathfind,'i');
										blocks[1] = blocks[1].replace(r,configdata.soundpathreplace);
									}
									if(loadfolder) {
										folderappend(lastlist,cleartext(blocks[1]));
									}
									else {
										blocks[2] = (typeof blocks[2] !== 'undefined' && blocks[2] != '') ? parseFloat(blocks[2]) : parseFloat(1);
										fileappend(lastlist,splitfile(cleartext(blocks[1])),blocks[2]);
									}
								}
							}
						});
					}
					changesmade = false;
				});
			});
		}
	});
	$('#save_scenario').click(function(){
		var store = ['music'];
		$('#playlists > div').each(function(){
			// block element
			if($(this).hasClass('block')) {
				store.push('block;'+csvtext($(this).find('.headtable input').val()));
			}
			// music element
			else {
				let line = 'playlist;'+csvtext($(this).find('.headtable input[name="playlist[]"]').val());
				line += ';'+$(this).find('.headtable select[name="playlistcolor[]"]').val();
				line += ';'+$(this).find('.headtable input[name="playlisticon[]"]').val();
				line += ';'+$(this).find('.headtable select[name="playlistrandom[]"]').val();
				line += ';'+$(this).find('.headtable input[name="playlistdyn[]"]').val();
				line += ';'+$(this).find('.headtable select[name="playlistkey[]"]').attr('data-val');
				store.push(line);
				let dynfolder = ($(this).find('.headtable input[name="playlistdyn[]"]').val() == 1) ? true : false;
				// get files
				$.each($(this).find('.file'),function(i,v){
					let line = 'file;'+csvtext($(this).find('input[name="filename[]"]').val());
					if(dynfolder) {
						line += ';1';
					}
					else {
						line += ';'+$(this).find('select[name="filevolume[]"]').val();
					}
					store.push(line);
				});
			}
		});
		store.push('sounds');
		$('#soundlists > div').each(function(){
			// block element
			if($(this).hasClass('block')) {
				store.push('block;'+csvtext($(this).find('.headtable input').val()));
			}
			// sound element
			else {
				let line = 'soundlist;'+csvtext($(this).find('.headtable input[name="soundlist[]"]').val());
				line += ';'+$(this).find('.headtable select[name="soundlistcolor[]"]').val();
				line += ';'+$(this).find('.headtable input[name="soundlisticon[]"]').val();
				line += ';'+$(this).find('.headtable select[name="soundvolume[]"]').val();
				line += ';'+$(this).find('.headtable select[name="soundrepeat[]"]').val();
				line += ';'+$(this).find('.headtable select[name="soundlistrandom[]"]').val();
				line += ';'+$(this).find('.headtable input[name="soundlistdyn[]"]').val();
				line += ';'+$(this).find('.headtable select[name="soundkey[]"]').attr('data-val');
				store.push(line);
				let dynfolder = ($(this).find('.headtable input[name="soundlistdyn[]"]').val() == 1) ? true : false;
				// get files
				$.each($(this).find('.file'),function(i,v){
					let line = 'file;'+csvtext($(this).find('input[name="filename[]"]').val());
					if(dynfolder) {
						line += ';1';
					}
					else {
						line += ';'+$(this).find('select[name="filevolume[]"]').val();
					}
					store.push(line);
				});
			}
		});
		// show save dialog
		dialog.showSaveDialog({
			filters: [{
				name: 'CSV',
				extensions: ['csv']
			}]
		},
   (filename) => {
			if(filename === undefined){
				return;
			}
			fs.writeFile(filename, csvcombine(store), (err) => {
				if(err){
					alert(langstrings.error_createfile + err.message)
					return;
				}
				alert(langstrings.filesaved);
				changesmade = false;
			});
		});
	});
	$('#navigation a').click(function(e){
		e.preventDefault();
		if(!changesmade || confirm(langstrings.confirm_new)) {
			window.location.href = $(this).attr('href');
		}
	});
});